<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Document</title>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css">
</head>

<body>
    <div class="container m-5">
        <button type="button" class="btn btn-primary m-2" onclick="getAllPosts()">Get All</button>
        <button type="button" class="btn btn-secondary m-2" onclick="getPostById()">Get Detail</button>
        <button type="button" class="btn btn-success m-2" onclick="createPost()">Create</button>
        <button type="button" class="btn btn-danger m-2" onclick="updatePost()">Update</button>
        <button type="button" class="btn btn-warning m-2" onclick="deletePost()">Delete</button>
        <button type="button" class="btn btn-warning m-2" onclick="getData()">Get data 1 to 2</button>
    </div>

    <script>
        const gURL = "https://jsonplaceholder.typicode.com/posts";

        function fetchAPI(url, options) {
            fetch(url, options)
                .then(
                    (response) => {
                        return response.json();
                    }
                )
                .then(
                    (data) => {
                        console.log(data);
                    }
                )
                .catch(
                    (error) => {
                        console.error(error);
                    }
                )
        }

        function getAllPosts() {
            fetchAPI(gURL, {
                method: "GET"
            })
        }

        function getPostById() {
            fetchAPI(gURL + "/1", {
                method: "GET"
            });
        }

        function createPost() {
            fetchAPI(gURL, {
                method: 'POST',
                headers: {
                    'Content-type': 'application/json; charset=UTF-8',
                },
                body: JSON.stringify({
                    title: 'foo',
                    body: 'bar',
                    userId: 1,
                })
            })
        }

        function updatePost() {
            fetchAPI(gURL + "/1", {
                method: 'PUT',
                headers: {
                    'Content-type': 'application/json; charset=UTF-8',
                },
                body: JSON.stringify({
                    title: 'foo',
                    body: 'bar',
                    userId: 1,
                })
            })
        }

        function deletePost() {
            fetchAPI(gURL + "/1", {
                method: 'DELETE'
            })
        }

        // Không sử dụng vì quá dài
        function getData() {
            fetch(gURL + "/1")
                .then(
                    (response) => {
                        return response.json();
                    }
                )
                .then(
                    (data) => {
                        console.log(data);

                          
                        fetch(gURL + "/2")
                            .then(
                                (response) => {
                                    return response.json();
                                }
                            )
                            .then(
                                (data) => {
                                    console.log(data);
                                }
                            )
                            .catch(
                                (error) => {
                                    console.error(error);
                                }
                            )
                                }
                            )
                .catch(
                    (error) => {
                        console.error(error);
                    }
                )
          
        }

    </script>
</body>

</html>